<template>
	<view>
		<uni-fab
			horizontal="right"
			vertical="bottom"
			@fabClick="toAdd"
		></uni-fab>
		<u-search  :show-action="false" v-model="searchForm.title" @change="inputWord" margin="20rpx 50rpx"></u-search>
		<view>
			<u-swipe-action>
				<view
					v-for="(notify, index) in dataList"
					:key="index">
						<u-swipe-action-item @click="del(notify.id)"  :key="notify.id" :threshold="60" duration="500" 
						:options="[ {
							text: '删除',
							style: {
								backgroundColor: '#f56c6c'
							}
						}]">
						  <u-cell-group>
							  <u-cell @click="toDetail(notify)">
								  <u-avatar slot="icon" icon="bell-fill" fontSize="22" randomBgColor></u-avatar>
								  <view slot="title" class="content">
										<view class="text-bold text-grey">
											<view class="ellipsis-description">
												 标题: {{notify.title}}
											</view>
										</view>
									
										<view class="text-gray text-sm">
											<view class="ellipsis-description">
												发布者：{{notify.createBy.name}}, {{notify.createTime}}
											</view>
										</view>
										<view class="text-sm">
											<view class="ellipsis-description">
												内容：{{notify.content}}
											</view>
										</view>
								  </view>
								  <view slot="right-icon">
									<u-tag :text="$dictUtils.getDictLabel('oa_notify_status', notify.status ,'')" v-if="notify.status === '1'" plain shape="circle"></u-tag>
									<u-tag :text="$dictUtils.getDictLabel('oa_notify_status', notify.status ,'')" v-else plain type="error" shape="circle"></u-tag>
								  </view>
								</u-cell>
						  </u-cell-group>
						</u-swipe-action-item>
				</view>
			</u-swipe-action>
		</view>
		<u-loadmore :status="status"  @loadmore="loadmore" :line="true" />
		<u-gap height="40" bgColor="#fff"></u-gap>
	</view>
</template>

<script>
	import notifyService from "@/api/notify/notifyService";	
	export default {
		data() {
			return {
				status: 'loadmore',
				searchForm: {
					title: ''
				},
				dataList: [],
				tablePage: {
					pages: 0,
					currentPage: 0,
					pageSize: 10,
					orders: [{ column: "a.create_time", asc: false }],
				},
				loading: false,
			}
		},
		created() {
			this.loadmore()
		},
		methods: {
			// 跳转到详细页面
			toDetail (notify) {
				if(notify.status === '1'){
					uni.navigateTo({
					  url: '/pages/apps/notification/notificationDetail?id='+notify.id
					})
				}else{
					this.toEdit(notify)
				}
				
			},
			toEdit (notify) {
				uni.navigateTo({
				  url: '/pages/apps/notification/oaNotifyForm?id='+notify.id
				})
			},
			toAdd (){
				uni.navigateTo({
				  url: '/pages/apps/notification/oaNotifyForm'
				})
			},
			// 输入监听
			inputWord(e){
				this.searchTimer && clearTimeout(this.searchTimer)
				this.searchTimer = setTimeout(()=>{
					this.doSearch()
				},300)
			},
			// 搜索
			doSearch(){
				this.dataList = []; 
				this.tablePage.currentPage = 0;
				this.tablePage.pageSize = 10;
				this.tablePage.pages = 0;
				this.loadmore()
			},
			onReachBottom() {
				this.loadmore()
			},
			loadmore() {
				if(this.tablePage.currentPage!==0 && this.tablePage.pages <= this.tablePage.currentPage ) {
					this.status = 'nomore';
					return;
				}
				this.tablePage.currentPage = ++ this.tablePage.currentPage;
				//联网加载数据
				this.status = 'loading';
				notifyService.list({
					current: this.tablePage.currentPage,
					size: this.tablePage.pageSize,
					orders: this.tablePage.orders,
					...this.searchForm
				}).then((data)=>{
					//追加新数据
					this.dataList=this.dataList.concat(data.records);
					this.tablePage.pages = data.pages;
					if(this.tablePage.pages <= this.tablePage.currentPage){
						this.status = 'nomore'
					} else {
						this.status = 'loadmore'
					}
				})
				
			},
			del (id) {
				notifyService.delete(id).then((data)=>{
					this.doSearch()
					uni.showToast({
						title: data,
						icon:"success"
					})
				})
			},
		}
	}
</script>